"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rxjs_1 = require("rxjs");
var SignalrCore = (function () {
    function SignalrCore() {
        this.isConnected = new rxjs_1.BehaviorSubject(false);
        this.methods = {};
        this.callbacks = {};
        this.recordSeparator = String.fromCharCode(0x1e);
        this.roomId = 0;
        this.socketUrl = '';
        this.protocol = {
            name: 'json',
            transferFormat: 1,
            version: 1,
            writeMessage: function (message) {
                return TextMessageFormat.write(JSON.stringify(message));
            }
        };
    }
    SignalrCore.prototype.start = function (httpURL) {
        var _this = this;
        this.socketUrl = httpURL.replace(/(http)(s)?\:\/\//, 'ws$2://');
        this.socketUrl += '?id=';
        var self = this;
        this.makeRequest('POST', httpURL + "/negotiate", function (err, data) {
            if (err) {
                console.log(err);
            }
            else {
                var connId = _this.socketUrl;
                if (typeof data === 'object') {
                    connId = data.connectionId;
                }
                else {
                    var _data = JSON.parse(data);
                    connId = _data.connectionId;
                }
                _this.socketUrl += connId;
                self.openSocketConnection(_this.socketUrl).then(function (res) {
                    _this.isConnected.next(true);
                });
            }
        });
        return this.isConnected.asObservable();
    };
    SignalrCore.prototype.openSocketConnection = function (socketUrl) {
        return __awaiter(this, void 0, void 0, function () {
            var p;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        p = new Promise(function (resolve, reject) {
                            _this.websocket = new WebSocket(socketUrl, _this.recordSeparator[JSON.stringify(_this.protocol)]);
                            _this.websocket.onopen = function (event) {
                                _this.websocket.send(JSON.stringify({ 'protocol': 'json', 'version': 1 }));
                                _this.websocket.send(_this.recordSeparator);
                            };
                            _this.websocket.onmessage = function (data) { return _this._onMessage(data); };
                            _this.websocket.onerror = function (err) { return reject(err); };
                            resolve(_this.websocket);
                        });
                        return [4, p.then(function (res) {
                                return res;
                            })];
                    case 1:
                        _a.sent();
                        return [2];
                }
            });
        });
    };
    SignalrCore.prototype.on = function (methodName, newMethod) {
        if (!methodName || !newMethod) {
            return;
        }
        methodName = methodName.toLowerCase();
        if (!this.methods[methodName]) {
            this.methods[methodName] = [];
        }
        if (this.methods[methodName].indexOf(newMethod) !== -1) {
            return;
        }
        this.methods[methodName].push(newMethod);
    };
    SignalrCore.prototype.invoke = function (methodName) {
        var _this = this;
        var args = [];
        for (var _a = 1; _a < arguments.length; _a++) {
            args[_a - 1] = arguments[_a];
        }
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var invocationDescriptor = this.createInvocation(methodName, args, false);
        var p = new Promise(function (resolve, reject) {
            _this.callbacks[invocationDescriptor.invocationId] = function (invocationEvent, error) {
                if (error) {
                    reject(error);
                    return;
                }
                else if (invocationEvent) {
                    if (invocationEvent.type === MessageType.Completion) {
                        if (invocationEvent.error) {
                            reject(new Error(invocationEvent.error));
                        }
                        else {
                            resolve(invocationEvent.result);
                        }
                    }
                    else {
                        reject(new Error('Unexpected message type: ' + invocationEvent.type));
                    }
                }
            };
            var message = _this.protocol.writeMessage(invocationDescriptor);
            _this.websocket.send(message);
        });
        return p;
    };
    SignalrCore.prototype.createInvocation = function (methodName, args, nonblocking) {
        if (nonblocking) {
            return {
                arguments: args,
                target: methodName,
                type: MessageType.Invocation,
            };
        }
        else {
            var id = this.roomId;
            this.roomId++;
            return {
                arguments: args,
                invocationId: id.toString(),
                target: methodName,
                type: MessageType.Invocation,
            };
        }
    };
    SignalrCore.prototype._onMessage = function (event) {
        var data = event.data, target = event.target;
        var parseData = TextMessageFormat.parse(data);
        var parseTarget = JSON.parse(parseData[0]);
        if (parseTarget && parseTarget['type'] && parseTarget['type'] !== 3) {
            if (parseTarget['type'] === MessageType.Invocation && parseTarget.target && this.methods[parseTarget.target.toLowerCase()]) {
                this.methods[parseTarget.target.toLowerCase()][0](parseTarget);
            }
        }
    };
    SignalrCore.prototype.makeRequest = function (method, url, done) {
        var xhr = new XMLHttpRequest();
        xhr.open(method, url);
        xhr.onload = function () {
            done(null, xhr.response);
        };
        xhr.onerror = function () {
            done(xhr.response);
        };
        xhr.send();
    };
    return SignalrCore;
}());
exports.SignalrCore = SignalrCore;
var MessageType;
(function (MessageType) {
    MessageType[MessageType["Invocation"] = 1] = "Invocation";
    MessageType[MessageType["StreamItem"] = 2] = "StreamItem";
    MessageType[MessageType["Completion"] = 3] = "Completion";
    MessageType[MessageType["StreamInvocation"] = 4] = "StreamInvocation";
    MessageType[MessageType["CancelInvocation"] = 5] = "CancelInvocation";
    MessageType[MessageType["Ping"] = 6] = "Ping";
    MessageType[MessageType["Close"] = 7] = "Close";
})(MessageType = exports.MessageType || (exports.MessageType = {}));
var TextMessageFormat = (function () {
    function TextMessageFormat() {
    }
    TextMessageFormat.write = function (output) {
        return "" + output + TextMessageFormat.RecordSeparator;
    };
    TextMessageFormat.parse = function (input) {
        if (input[input.length - 1] !== TextMessageFormat.RecordSeparator) {
            throw new Error('incomplete.');
        }
        var messages = input.split(TextMessageFormat.RecordSeparator);
        messages.pop();
        return messages;
    };
    TextMessageFormat.RecordSeparatorCode = 0x1e;
    TextMessageFormat.RecordSeparator = String.fromCharCode(TextMessageFormat.RecordSeparatorCode);
    return TextMessageFormat;
}());
exports.TextMessageFormat = TextMessageFormat;
//# sourceMappingURL=nativescript-signalr-core.service.js.map